﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Drawing.Text;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace PuzzlePlayer_Namespace
{
    internal class Skyscrapers : Board
    {
        public int[,] visionState;
        public Skyscrapers(int boardSize = 6)
        {
            boardState = GetClearBoard(boardSize);
            lastGeneratedBoard = GetClearBoard(boardSize);
            description = "lol";
            drawFactor = 1;
        }
        public override void Draw(Graphics gr, Rectangle r)
        {
            gr.TextRenderingHint = TextRenderingHint.AntiAlias;
            Size tilesize = new Size(r.Width / boardState.GetLength(0), r.Height / boardState.GetLength(1));
            int stringsize = Math.Min(tilesize.Height / 2, tilesize.Width) * 2 * 1 / 2;
            StringFormat stringFormat = new StringFormat();
            stringFormat.LineAlignment = StringAlignment.Center;
            stringFormat.Alignment = StringAlignment.Center;
            gr.FillRectangle(Brushes.Beige, r.X + tilesize.Width, r.Y + tilesize.Height, r.Width - 2 * tilesize.Width, r.Height - 2 * tilesize.Height);
            for (int i = 0; i < boardState.GetLength(0); i++)
            {
                for (int j = 0; j < boardState.GetLength(1); j++)
                {
                    if (i == 0 || i == boardState.GetLength(0) - 1 || j == 0 || j == boardState.GetLength(1) - 1)
                    {
                        if (boardState[i, j] != emptySpace)
                        {
                            gr.DrawString(Convert.ToString(boardState[i, j]),
                            new Font("Verdana", stringsize / 2),
                            Brushes.Black,
                            (int)(r.X + ((double)i + 0.5) * tilesize.Width),
                            (int)(r.Y + ((double)j + 0.5) * tilesize.Height),
                            stringFormat);
                        }
                    }
                    else
                    {
                        gr.DrawRectangle(Pens.DarkGray,
                        r.X + i * tilesize.Width,
                        r.Y + j * tilesize.Height,
                        tilesize.Width,
                        tilesize.Height);
                        if (boardState[i, j] != emptySpace)
                        {
                            gr.DrawString(Convert.ToString(boardState[i, j]),
                            new Font("Verdana", stringsize),
                            Brushes.Black,
                            (int)(r.X + ((double)i + 0.5) * tilesize.Width),
                            (int)(r.Y + ((double)j + 0.5) * tilesize.Height),
                            stringFormat);
                        }
                    }
                }
            }
        }

        public override SOLUTIONS Solve(bool CheckOnly)
        {
            return SOLUTIONS.NONE;
        }

        public override void Generate()
        {
            throw new NotImplementedException();
        }

        public override void TileInput(Point? p, Keys k)
        {
            if (p == null) return;
            int num = (int)k - 48;
            if (num > 0 && num <= boardState.GetLength(0)) boardState[((Point)p).X, ((Point)p).Y] = num;
        }

        protected override List<Move> GetSolveList(int[,] boardToSolve)
        {
            return new List<Move>();
        }
    }
}
